//+------------------------------------------------------------------+
//|                                                R2_Arrows_v4a.mq4 |
//|           Copyright  2007 , transport_david , David W Honeywell |
//|                                     hellonwheels.trans@gmail.com |
//+------------------------------------------------------------------+

#property copyright "Copyright  2007 , transport_david , David W Honeywell"
#property link      "hellonwheels.trans@gmail.com"

#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1  Yellow
#property indicator_color2  Red
#property indicator_color3  Lime
#property indicator_color4  LightGray
#property indicator_color5  LightGray

extern bool   Use_Hull            =   false;
extern int    HmaPeriod           =     200;
extern int    HmaPrice            =     PRICE_CLOSE;

extern string s1 = "---------------";
extern int    Ma_Periods          =     200;
extern int    Ma_Type_if_not_Hull =       0; // only if Use_Hull = false
extern int    Ma_Applied_Price    =       0;

extern string s2 = "---------------";
extern int    RsiPeriods          =       2;
extern int    Rsi_Applied_Price   =       0;

extern string s3 = "---------------";
extern int    BuyIfDay1RsiBelow   =      65; // 1st day of tracking must be < this setting
extern int    BuyIfDay3RsiBelow   =      65; // 3rd day must be < this setting

extern string s4 = "---------------";
extern int    SellIfDay1RsiAbove  =      35; // 1st day of tracking must be > this setting
extern int    SellIfDay3RsiAbove  =      35; // 3rd day must be > this setting

extern string s5 = "---------------";
extern int    CloseBuyIfRsiAbove  =      75;
extern int    CloseSellIfRsiBelow =      25;

extern string s6 = "---------------";
extern string note                =      "turn on Alert = true; turn off = false";
extern bool   alertsOn            =      true;
extern bool   alertsOnCurrent     =      false;
extern bool   alertsOnBuyorSell   =      true;
extern bool   alertsOnRsiClose    =      true;
extern bool   alertsMessage       =      true;
extern bool   alertsSound         =      true;
extern bool   alertsNotify        =      false;
extern bool   alertsEmail         =      false;

double Trend_Ma[];
double Sell_Arrow[];
double Buy_Arrow[];
double Close_SellTrade_Marker[];
double Close_BuyTrade_Marker[];
double trend1[];
double trend2[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,Trend_Ma);                                                                  SetIndexLabel(0,"Trend_Ma_Periods ( "+Ma_Periods+")");
   SetIndexBuffer(1,Sell_Arrow);             SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,234); SetIndexLabel(1,"Sell_Arrow (RsiPeriods "+RsiPeriods+")");
   SetIndexBuffer(2,Buy_Arrow);              SetIndexStyle(2,DRAW_ARROW); SetIndexArrow(2,233); SetIndexLabel(2,"Buy_Arrow (RsiPeriods "+RsiPeriods+")");
   SetIndexBuffer(3,Close_SellTrade_Marker); SetIndexStyle(3,DRAW_ARROW); SetIndexArrow(3,172); SetIndexLabel(3,"Close_SellTrade_Marker");
   SetIndexBuffer(4,Close_BuyTrade_Marker);  SetIndexStyle(4,DRAW_ARROW); SetIndexArrow(4,172); SetIndexLabel(4,"Close_BuyTrade_Marker");
   SetIndexBuffer(5,trend1);
   SetIndexBuffer(6,trend2);
return(0);
}
 
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
    int counted_bars=IndicatorCounted();
    int shift,limit;

    if(counted_bars<0) return(-1);
    if(counted_bars>0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1);
    
    //
    //
    //
    //
    //
    
    for (shift = limit; shift >= 0; shift--)
    { 
        if (Use_Hull)
        {
          Trend_Ma[shift] = iHull(iMA(NULL,0,1,0,MODE_SMA,HmaPrice,shift),HmaPeriod,shift);
        }
        else
        {
          Trend_Ma[shift] = iMA(Symbol(), 0, Ma_Periods,0,Ma_Type_if_not_Hull,Ma_Applied_Price,shift);
        }
        
        double Day1 = iRSI(Symbol(),0,RsiPeriods,Rsi_Applied_Price,shift+3);
        double Day2 = iRSI(Symbol(),0,RsiPeriods,Rsi_Applied_Price,shift+2);
        double Day3 = iRSI(Symbol(),0,RsiPeriods,Rsi_Applied_Price,shift+1);
        double Today = iRSI(Symbol(),0,RsiPeriods,Rsi_Applied_Price,shift);
       
       //- Sell Arrows ---
       trend1[shift] = 0;
       if ((iClose(Symbol(),0,shift+1) < Trend_Ma[shift+1]) && (Day1 > SellIfDay1RsiAbove) && (Day2 > Day1) && (Day3 > Day2) && (Day3 > SellIfDay3RsiAbove) )
          
       { Sell_Arrow[shift] = iHigh(Symbol(),0,shift) + (20*Point); trend1[shift] =-1; }//High arrow Sell
       
       //- Buy Arrows ---
       
       if ((iClose(Symbol(),0,shift+1) > Trend_Ma[shift+1]) && (Day1 < BuyIfDay1RsiBelow) && (Day2 < Day1) && (Day3 < Day2) && (Day3 < BuyIfDay3RsiBelow) )
          
       { Buy_Arrow[shift] = iLow(Symbol(),0,shift) - (20*Point);  trend1[shift] = 1; } //Low arrow Buy 
       
       //- Close Trades Marker ---
       trend2[shift] = 0;
       if (Today < CloseSellIfRsiBelow)
         
       { Close_SellTrade_Marker[shift] = iLow(Symbol(),0,shift) - (50*Point); trend2[shift] = 1; }
       
       if (Today > CloseBuyIfRsiAbove)
         
       { Close_BuyTrade_Marker[shift] = iHigh(Symbol(),0,shift) + (50*Point); trend2[shift] =-1; }
      
      }
      
      //
      //
      //
      //
      //
      
      if (alertsOn)
      {
       if (alertsOnCurrent)
            int whichBar = 0;
       else     whichBar = 1; 
      
       //
       //
       //
       //
       //
      
       static datetime time1 = 0;
       static string   mess1 = "";
         if (alertsOnBuyorSell && trend1[whichBar] != trend1[whichBar+1])
         {
            if (trend1[whichBar] ==  1) doAlert(time1,mess1,whichBar," R2 Buy");
            if (trend1[whichBar] == -1) doAlert(time1,mess1,whichBar," R2 Sell");
         }            
       static datetime time2 = 0;
       static string   mess2 = "";
         if (alertsOnRsiClose && trend2[whichBar] != trend2[whichBar+1])
         {
            if (trend2[whichBar] ==  1) doAlert(time2,mess2,whichBar," R2 Close Sell");
            if (trend2[whichBar] == -1) doAlert(time2,mess2,whichBar," R2 Close Buy");
         }            
   }
return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//


double workHull[][2];
double iHull(double price, double period, int r, int instanceNo=0)
{
   if (ArrayRange(workHull,0)!= Bars) ArrayResize(workHull,Bars); r=Bars-r-1;

   //
   //
   //
   //
   //

      int tHmaPeriod = MathMax(period,2);
      int HalfPeriod = MathFloor(HmaPeriod/2);
      int HullPeriod = MathFloor(MathSqrt(HmaPeriod));
      double hma,hmw,weight; instanceNo *= 2;

         workHull[r][instanceNo] = price;

         //
         //
         //
         //
         //
               
         hmw = HalfPeriod; hma = hmw*price; 
            for(int k=1; k<HalfPeriod && (r-k)>=0; k++)
            {
               weight = HalfPeriod-k;
               hmw   += weight;
               hma   += weight*workHull[r-k][instanceNo];  
            }             
            workHull[r][instanceNo+1] = 2.0*hma/hmw;

         hmw = HmaPeriod; hma = hmw*price; 
            for(k=1; k<period && (r-k)>=0; k++)
            {
               weight = HmaPeriod-k;
               hmw   += weight;
               hma   += weight*workHull[r-k][instanceNo];
            }             
            workHull[r][instanceNo+1] -= hma/hmw;

         //
         //
         //
         //
         //
         
         hmw = HullPeriod; hma = hmw*workHull[r][instanceNo+1];
            for(k=1; k<HullPeriod && (r-k)>=0; k++)
            {
               weight = HullPeriod-k;
               hmw   += weight;
               hma   += weight*workHull[r-k][1+instanceNo];  
            }
   return(hma/hmw);
}

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)+doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," R2 "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}



 
